#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

string getWord1(string str, int a);
string getWord2(string str, int a);

bool success = 0;

class Rule {
public:
    string rule;
    int arrow;
    int searchArrow();
    bool endRule;
public:
    Rule(string rule_);
    string getFirst();
    string getSecond();
    string runRule(string input);
    string replace(string input, string str, int a, int b);
    string getRule();
    bool isEnd();
};

Rule::Rule(string rule_) : rule(rule_) {
    endRule = 0;
    searchArrow();
}

bool Rule::isEnd() {
    return endRule;
}

int Rule::searchArrow() {
    for(int i = 0; i < rule.size(); ++i) {
        if((rule[i] == '-' || rule[i] == '=') && i < rule.size()-1) {
            if(rule[i] == '=') {endRule = 1;}
            if(rule[i+1] == '>') {arrow = i; return 0;}
        }
    }

    arrow = -1;
}

string Rule::getFirst() {
    string res;

    for(int i = 0; i < arrow; ++i) {
        res.push_back(rule[i]);
    }

    return res;
}

string Rule::getSecond() {
    string res;

    for(int i = arrow + 2; i < rule.size(); ++i) {
        res.push_back(rule[i]);
    }

    return res;
}

string Rule::runRule(string input) {
    if(arrow == -1) {
        cout << "Правило \"" << rule << "\" некорректно. Исправьте ошибку.";
        //success = 0;
        return "";
    }

    string first = getFirst();
    string second = getSecond();

    if(first.size() == 0) {
        string res = second;

        for(int i = 0; i < input.size(); ++i) {
            res.push_back(input[i]);
        }

        success = 1;

        return res;
    }

    int a = -1, b = -1;

    if(first.size() > input.size()) {return input;}
    bool stop = 0;
    for(int i = 0; i < input.size(); ++i) {
        if(stop) {break;}
        for(int j = 0; j < first.size() && input[i+j] == first[j]; ++j) {
            if(j == first.size()-1) {a = i, b = i + first.size(); stop = 1; success = 1; break;}
        }
    }

    if(a == -1) {return input;}

    return replace(input, second, a, b);
}

string Rule::replace(string input, string str, int a, int b) {
    string res;

    for(int i = 0; i < a; ++i) {
        res.push_back(input[i]);
    }

    for(int i = 0; i < str.size(); ++i) {
        res.push_back(str[i]);
    }

    for(int i = b; i < input.size(); ++i) {
        res.push_back(input[i]);
    }

    return res;
}

string Rule::getRule() {
    return rule;
}

int main() {
    //setlocale(0,"");

    ifstream src("src.txt");
    string line;
    string input;
    ifstream in("input.txt");
    getline(in, input);
    vector<Rule>rules;
    string test;

    while(!src.eof()) {
        getline(src, line);
        rules.push_back(Rule(line));
    }
    char a;
    int r = 0;
    string old;

    int i = 0;
    while(1) {
            success = 0;
        input = rules[i].runRule(input);
        if(input == old && success) {
            ++r;
        }
        else {
            r = 0;
            old = input;
        }
        if(r >= 3) {break;}
        bool endd = rules[i].isEnd();
        if(success) {cout << i << " Правило: " << rules[i].getRule() << " " << input << endl << endl;}
        if(endd && success) {break;}
        if(success) {i = 0; continue;}
        ++i;
        if(i == rules.size() && !success) {break;}
        if(i == rules.size()) {i = 0;}
    }

    cout << "Результат: " << input;
}
